#!/usr/bin/bash

   # 设置默认登录密码
    debian_password="debian"  

    # 设置默认用户的密码
    echo "Setting default login password..."
    sudo adduser debian
    echo "debian:$debian_password" | sudo chpasswd   

  #配置java
  # 创建存放 java 的目录
  mkdir -p /java
  #安装java环境
  sudo apt-get update -y
  sudo apt-get install openjdk-17-jdk -y
  #移动到指定目录
  # sudo cp -r /usr/lib/jvm/java-17-openjdk-amd64/* /java


  #配置git
  echo "installing git..."
  sudo apt-get install git -y

    #从git拉取公钥
  sudo chmod 700 /root/.ssh
  sudo touch /root/.ssh/known_hosts
  sudo chmod 700 /root/.ssh/known_hosts
  #sudo sh -c 确保使用root权限
  sudo sh -c "ssh-keyscan git.cardiff.ac.uk >> /root/.ssh/known_hosts"
  sudo chmod 600 /root/.ssh/known_hosts

  echo "creating gitlab_project_keypair.key..."
  #touch 创建gitlab_project_keypair.key
  sudo touch /root/.ssh/gitlab_project_keypair.key
  #cat将内容写入gitlab_project_keypair.key(EOF开始到EOF结束)
sudo bash -c 'cat << EOF > /root/.ssh/gitlab_project_keypair.key
-----BEGIN OPENSSH PRIVATE KEY-----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-----END OPENSSH PRIVATE KEY-----
EOF'

  # 设置文件权限
  sudo chmod 600 /root/.ssh/gitlab_project_keypair.key

  #克隆项目 克隆到/root/healthcare
  sudo sh -c "ssh-agent bash -c 'ssh-add /root/.ssh/gitlab_project_keypair.key; git clone --branch wyl git@git.cardiff.ac.uk:c24025433/healthcare.git /root/healthcare'"



  #配置gradle

  # 创建存放 Gradle 的目录
  mkdir -p /gradle
  # 下载 Gradle 8.7
  wget https://services.gradle.org/distributions/gradle-8.7-bin.zip -P /gradle
  # 更新软件包列表并安装 unzip
  sudo apt-get update -y
  sudo apt-get install -y unzip
  #安装vim
  sudo apt-get install -y vim
  # 解压 Gradle
  unzip /gradle/gradle-8.7-bin.zip -d /gradle
  # 配置环境变量
  echo "export PATH=$PATH:/gradle/gradle-8.7/bin" >> /etc/profile

  source /etc/profile

  #安装依赖工具
sudo apt update
sudo apt install -y ca-certificates curl gnupg
#添加Docker的GPG密钥
sudo install -m 0755 -d /etc/apt/keyrings
curl -fsSL https://download.docker.com/linux/debian/gpg | sudo gpg --dearmor -o /etc/apt/keyrings/docker.gpg
sudo chmod a+r /etc/apt/keyrings/docker.gpg
#添加Docker的APT源
echo \
  "deb [arch=$(dpkg --print-architecture) signed-by=/etc/apt/keyrings/docker.gpg] https://download.docker.com/linux/debian \
  $(. /etc/os-release && echo "$VERSION_CODENAME") stable" | \
  sudo tee /etc/apt/sources.list.d/docker.list > /dev/null
#更新并安装Docker
sudo apt update
sudo apt install -y docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin
#启动Docker服务并设置开机自启
sudo systemctl enable --now docker

echo "docker version"
sudo docker -v

sudo -i bash -c "cd /root/healthcare && gradle build"


#创建nginx宿主机配置文件
sudo mkdir -p /nginx
sudo touch /nginx/nginx.conf
sudo sh -c 'cat <<EOF > /nginx/nginx.conf


  #user  nobody;
  worker_processes  1;

  events {
      worker_connections  1024;
  }

  http {
      upstream healthcare {
        server healthcare_01:8080;
        server healthcare_02:8080;
      }
      include       mime.types;
      default_type  application/octet-stream;
      sendfile        on;

      keepalive_timeout  65;

      gzip  on;

      server {
          listen       80;
          server_name  www.cardiff.healthcare;

      location /static/html/ {
          alias   /root/healthcare/src/main/resources/static/html/;
      }

      location /static/img/ {
          alias    /root/healthcare/src/main/resources/static/img/;
      }

      location /static/css/ {
          alias    /root/healthcare/src/main/resources/static/css/;
      }

      location /static/js/ {
          alias    /root/healthcare/src/main/resources/static/js/;
      }

      location /templates/ {
          alias /root/healthcare/src/main/resources/templates/;
      }

      location / {
          proxy_pass http://healthcare;
      }

          error_page   500 502 503 504  /50x.html;
          location = /50x.html {
              root   html;
          }
      }

  }
EOF'


#挂载sql
mkdir -p /root/healthcare/mariadb/init

cp /root/healthcare/src/main/resources/healthcare.sql /root/healthcare/mariadb/init/

#执行docker-compose
sudo docker compose -f /root/healthcare/Docker/docker-compose.yml up -d



  # #配置terraform
  # sudo apt-get update && sudo apt-get install -y gnupg software-properties-common

  # wget -O- https://apt.releases.hashicorp.com/gpg | \
  # gpg --dearmor | \
  # sudo tee /usr/share/keyrings/hashicorp-archive-keyring.gpg > /dev/null

  # gpg --no-default-keyring \
  # --keyring /usr/share/keyrings/hashicorp-archive-keyring.gpg \
  # --fingerprint

  # echo "deb [signed-by=/usr/share/keyrings/hashicorp-archive-keyring.gpg] \
  # https://apt.releases.hashicorp.com $(lsb_release -cs) main" | \
  # sudo tee /etc/apt/sources.list.d/hashicorp.list

  # sudo apt update

  # sudo apt-get install terraform

  # sudo terraform --version



  # 确保加载环境变量

  #sudo -i bash -c "cd /root/healthcare && gradle build && gradle bootrun"

