package com.cardiff.wylTest;

import com.cardiff.client_project.pojo.dto.SelectDTO;
import com.cardiff.client_project.pojo.dto.SignUserDTO;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.sql.SQLOutput;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class JunitTest {

    private static final Logger log = LoggerFactory.getLogger(JunitTest.class);

    /**
     * SignUserDTO class test
     *  private String name;
     *     private String password;
     *     private String email;
     *     private String phone;
     *     private String address;
     *     private String type;
     *     private String role;
     *     private int status;
     */
    @Test
    void TrueJuintTestDTO(){


       SignUserDTO signUserDTO = new SignUserDTO("wyl","123","WangY567@cardiff.ac.uk","123456","city road","admin","SUPER",1);
       assertEquals(signUserDTO.getName(),"wyl");
       assertEquals(signUserDTO.getPassword(),"123");
       assertEquals(signUserDTO.getEmail(),"WangY567@cardiff.ac.uk");
       assertEquals(signUserDTO.getPhone(),"123456");
       assertEquals(signUserDTO.getAddress(),"city road");
       assertEquals(signUserDTO.getRole(),"SUPER");
       assertEquals(signUserDTO.getStatus(),1);

    }


    /**
     *     private int id;
     *     private String name;
     *     private String email;
     *     private String phone;
     *     private String address;
     *     private String type;
     *     private String role;
     *     private int maxAmount;
     *     private int amountPatient;
     *     private int status;
     *     private Date freetime;
     *     private int roleId;
     */
    @Test
    void TrueJuintTestSelectDto(){
        Date date = new Date();
        SelectDTO selectDTO = new SelectDTO(1,"wyl","WangY567@cardiff.ac.uk","123","cardiff","ADMIN","ADMIN",100,50,1,date,1);
        assertEquals(selectDTO.getName(),"wyl");
        assertEquals(selectDTO.getEmail(),"WangY567@cardiff.ac.uk");
        assertEquals(selectDTO.getPhone(),"123");
        assertEquals(selectDTO.getAddress(),"cardiff");
        assertEquals(selectDTO.getRole(),"ADMIN");
        assertEquals(selectDTO.getType(),"ADMIN");
        assertEquals(selectDTO.getStatus(),1);
        assertEquals(selectDTO.getAmountPatient(),50);
        assertEquals(selectDTO.getMaxAmount(),100);
        assertEquals(selectDTO.getFreetime().getYear(),2025-1900);
        assertEquals(selectDTO.getRoleId(),1);


    }



}
